// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_admin

import (
	context "context"
	api "gitlab.com/BetaCompany/Freeje/sdk/go/api"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// SubscriptionsClient is the client API for Subscriptions service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type SubscriptionsClient interface {
	//Создание нового потока уведомлений в модели подписки  (на входе пустой объект, на выходе данные по
	// очереди для подписки), любое уведомление хранится не более 7 дней
	Create(ctx context.Context, in *api.Subscription, opts ...grpc.CallOption) (*api.Subscription, error)
	//Удаляет подписку и все данные в ней
	Delete(ctx context.Context, in *api.Subscription, opts ...grpc.CallOption) (*api.Subscription, error)
	//Запрашивает обновления по подписке
	Poll(ctx context.Context, in *api.Subscription, opts ...grpc.CallOption) (Subscriptions_PollClient, error)
	//Удаляет из очереди все уведомления с seq_no  меньше или равным Subscription.seq_no
	Flush(ctx context.Context, in *api.Subscription, opts ...grpc.CallOption) (*api.Subscription, error)
}

type subscriptionsClient struct {
	cc grpc.ClientConnInterface
}

func NewSubscriptionsClient(cc grpc.ClientConnInterface) SubscriptionsClient {
	return &subscriptionsClient{cc}
}

func (c *subscriptionsClient) Create(ctx context.Context, in *api.Subscription, opts ...grpc.CallOption) (*api.Subscription, error) {
	out := new(api.Subscription)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Subscriptions/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *subscriptionsClient) Delete(ctx context.Context, in *api.Subscription, opts ...grpc.CallOption) (*api.Subscription, error) {
	out := new(api.Subscription)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Subscriptions/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *subscriptionsClient) Poll(ctx context.Context, in *api.Subscription, opts ...grpc.CallOption) (Subscriptions_PollClient, error) {
	stream, err := c.cc.NewStream(ctx, &Subscriptions_ServiceDesc.Streams[0], "/com.freeje.api.admin.Subscriptions/Poll", opts...)
	if err != nil {
		return nil, err
	}
	x := &subscriptionsPollClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Subscriptions_PollClient interface {
	Recv() (*Notification, error)
	grpc.ClientStream
}

type subscriptionsPollClient struct {
	grpc.ClientStream
}

func (x *subscriptionsPollClient) Recv() (*Notification, error) {
	m := new(Notification)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *subscriptionsClient) Flush(ctx context.Context, in *api.Subscription, opts ...grpc.CallOption) (*api.Subscription, error) {
	out := new(api.Subscription)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Subscriptions/Flush", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// SubscriptionsServer is the server API for Subscriptions service.
// All implementations should embed UnimplementedSubscriptionsServer
// for forward compatibility
type SubscriptionsServer interface {
	//Создание нового потока уведомлений в модели подписки  (на входе пустой объект, на выходе данные по
	// очереди для подписки), любое уведомление хранится не более 7 дней
	Create(context.Context, *api.Subscription) (*api.Subscription, error)
	//Удаляет подписку и все данные в ней
	Delete(context.Context, *api.Subscription) (*api.Subscription, error)
	//Запрашивает обновления по подписке
	Poll(*api.Subscription, Subscriptions_PollServer) error
	//Удаляет из очереди все уведомления с seq_no  меньше или равным Subscription.seq_no
	Flush(context.Context, *api.Subscription) (*api.Subscription, error)
}

// UnimplementedSubscriptionsServer should be embedded to have forward compatible implementations.
type UnimplementedSubscriptionsServer struct {
}

func (UnimplementedSubscriptionsServer) Create(context.Context, *api.Subscription) (*api.Subscription, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedSubscriptionsServer) Delete(context.Context, *api.Subscription) (*api.Subscription, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedSubscriptionsServer) Poll(*api.Subscription, Subscriptions_PollServer) error {
	return status.Errorf(codes.Unimplemented, "method Poll not implemented")
}
func (UnimplementedSubscriptionsServer) Flush(context.Context, *api.Subscription) (*api.Subscription, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Flush not implemented")
}

// UnsafeSubscriptionsServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to SubscriptionsServer will
// result in compilation errors.
type UnsafeSubscriptionsServer interface {
	mustEmbedUnimplementedSubscriptionsServer()
}

func RegisterSubscriptionsServer(s grpc.ServiceRegistrar, srv SubscriptionsServer) {
	s.RegisterService(&Subscriptions_ServiceDesc, srv)
}

func _Subscriptions_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.Subscription)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SubscriptionsServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Subscriptions/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SubscriptionsServer).Create(ctx, req.(*api.Subscription))
	}
	return interceptor(ctx, in, info, handler)
}

func _Subscriptions_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.Subscription)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SubscriptionsServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Subscriptions/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SubscriptionsServer).Delete(ctx, req.(*api.Subscription))
	}
	return interceptor(ctx, in, info, handler)
}

func _Subscriptions_Poll_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.Subscription)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(SubscriptionsServer).Poll(m, &subscriptionsPollServer{stream})
}

type Subscriptions_PollServer interface {
	Send(*Notification) error
	grpc.ServerStream
}

type subscriptionsPollServer struct {
	grpc.ServerStream
}

func (x *subscriptionsPollServer) Send(m *Notification) error {
	return x.ServerStream.SendMsg(m)
}

func _Subscriptions_Flush_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.Subscription)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SubscriptionsServer).Flush(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Subscriptions/Flush",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SubscriptionsServer).Flush(ctx, req.(*api.Subscription))
	}
	return interceptor(ctx, in, info, handler)
}

// Subscriptions_ServiceDesc is the grpc.ServiceDesc for Subscriptions service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Subscriptions_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.admin.Subscriptions",
	HandlerType: (*SubscriptionsServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _Subscriptions_Create_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _Subscriptions_Delete_Handler,
		},
		{
			MethodName: "Flush",
			Handler:    _Subscriptions_Flush_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "Poll",
			Handler:       _Subscriptions_Poll_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "admin/subscriptions.proto",
}
